unit uFrmMain;

interface

uses
  System.SysUtils, Vcl.Forms, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, WEBLib.Controls, WEBLib.ExtCtrls,
  uSubForm1, uSubForm2, WEBLib.Buttons, WEBLib.TMSFNCPageControl;

type
  TFrmMain = class(TWebForm)
    txtSampleText: TWebEdit;
    lbTextsMain: TWebListBox;
    WebLabel1: TWebLabel;
    btCreateSubF1: TWebButton;
    btRemoveSubForm: TWebButton;
    btTransferSet: TWebButton;
    btCreateSubF2: TWebButton;
    btTransferGet: TWebButton;
    WebButton2: TWebButton;
    WebBitBtn1: TWebBitBtn;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    procedure btCreateSubF1Click(Sender: TObject);
    procedure btRemoveSubFormClick(Sender: TObject);
    procedure btTransferSetClick(Sender: TObject);
    procedure btCreateSubF2Click(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure WebBitBtn1Click(Sender: TObject);
    procedure btTransferGetClick(Sender: TObject);
    procedure WebButton2Click(Sender: TObject);
  public
    frm: TWebForm;
    p: TWebPanel;
    pg: TTMSFNCPageControl;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}


procedure TFrmMain.btCreateSubF1Click(Sender: TObject);

  procedure AfterCreate(AForm: TObject);
  begin
    if Assigned(frm) and (frm is TSubForm1) then
      ( frm as TSubForm1 ).lbTexts.Items.Assign(lbTextsMain.Items);
  end;

begin
  // destroy possible old form
  if Assigned(frm) then
    frm.Close;

  frm :=  TSubForm1.CreateNew(p.ElementID, @AfterCreate);
  btTransferGet.Enabled := true;
  btTransferSet.Enabled := true;
end;

procedure TFrmMain.btRemoveSubFormClick(Sender: TObject);
begin
  // destroy possible old form
  if Assigned(frm) then
  begin
    frm.Close;
    frm := nil;
  end;

  btTransferGet.Enabled := false;
  btTransferSet.Enabled := false;
end;

procedure TFrmMain.btTransferSetClick(Sender: TObject);
begin
  if Assigned(frm) and (frm is TSubForm1) then
    ( frm as TSubForm1 ).lbTexts.Items.Assign(lbTextsMain.Items);
end;

procedure TFrmMain.btCreateSubF2Click(Sender: TObject);
begin
  // destroy possible old form
  if Assigned(frm) then
    frm.Close;

  frm :=  TSubForm2.CreateNew(p.ElementID, nil);
  btTransferGet.Enabled := false;
  btTransferSet.Enabled := false;
end;

procedure TFrmMain.WebBitBtn1Click(Sender: TObject);
begin
   lbTextsMain.Items.Add(txtSampleText.Text);
end;

procedure TFrmMain.btTransferGetClick(Sender: TObject);
begin
  if Assigned(frm) and (frm is TSubForm1) then
    lbTextsMain.Items.Assign((frm as TSubForm1).lbTexts.Items);
end;

procedure TFrmMain.WebButton2Click(Sender: TObject);
begin
  lbTextsMain.Items.Clear;
end;

procedure TFrmMain.WebFormCreate(Sender: TObject);
begin
  frm := nil;
  pg := TTMSFNCPageControl.Create(Self);
  pg.Parent := Self;
  pg.DisableBackground;
  pg.Left := 20;
  pg.Top := 400;
  pg.Pages.Add;
  p := TWebPanel.Create(Self);
  p.Parent := pg.PageContainers[0];
  p.Align := alClient;
  p.AlignWithMargins := True;
end;

end.
